import { _decorator, Component, MeshRenderer, renderer, Vec4 } from 'cc';
const { ccclass, property } = _decorator;


@ccclass('meshTouchCtrl')
export class meshTouchCtrl extends Component {

    @property
    waveDis = 0.4;
    @property
    waveSpeed = 1;
    @property
    waveStr = 0.5;

    public waveProp: Vec4 = new Vec4();
    private _pass: renderer.Pass;
    private _handle: number;

    start() {

        this._pass = this.node.getComponent(MeshRenderer).material.passes[0];

        this.waveProp.w = 100;

        this.waveProp.z = this.waveStr;

        this._handle = this._pass.getHandle("waveFactor");
    }

    update(dt) {

        if (this.waveProp.w < 100) {

            this.waveProp.w += dt * this.waveSpeed;
            if (this.waveProp.w > this.waveDis) {
                this.waveProp.w = 100;
            }
            this._pass.setUniform(this._handle, this.waveProp);

        }

    }

}

